﻿/*********************
DECLARE VARIBLES HERE 
*********************/
var selectedLanguage;
var selectedReport;
var selectedReportType = 0;
var lang = {};
var geoLatitude;
var geoLongitude;
//var countryCode;
var countryName;
var imageBase64String;
var valid = true;

var json_language =
  [
    { "name": "English", "code": "en" },
    { "name": "Español", "code": "es" },
    { "name": "Français", "code": "fr" },
    { "name": "Português", "code": "pt" },
    { "name": "ру́сский", "code": "ru" },
    { "name": "ภาษาไทย", "code": "th" },
    { "name": "中国", "code": "zh" },
    { "name": "Dutch", "code": "nl" },
    { "name": "العربية", "code": "ar" },
    { "name": "हिन्दी भाषा", "code": "hi" }
//   { "name": "ភាសាខ្មែរ", "code": "km"}
  ];



/***GETTER FUNCTIONS***/
//Location of Activity
function getLOAType() {
    //return $('#m1-Report-LocationOfActivity-hidden-select-loa_type').val();
    return $('#m1-Report-LocationOfActivity-loa_type').val();
}
function getLOACountry() {
    // return $('#m1-Report-LocationOfActivity-hidden-select-loa_country').val();
    return $('#m1-Report-LocationOfActivity-loa_country').val();
}
function getLOACity() {
    return $('#m1-Report-LocationOfActivity-loa_city').val();
}
function getLOAStreet() {
    return $('#m1-Report-LocationOfActivity-loa_street').val();
}
function getLOATranMethod() {
    return $('#m1-Report-LocationOfActivity-loa_tranMethod').val();
}
function getLOATranID() {
    return $('#m1-Report-LocationOfActivity-loa_tranID').val();
}
function getLOADetail() {
    return $('#m1-Report-LocationOfActivity-loa_detail').val();
}
//Physical description
function getPDSex() {
    return $('#m1-Report-PhysicalDescription-pd_sex').val();
}
function getPDAge() {
    return $('#m1-Report-PhysicalDescription-pd_age').val();
}
function getPDNationality() {
    return $('#m1-Report-PhysicalDescription-pd_nationality').val();
}
function getPDEthnicity() {
    return $('#m1-Report-PhysicalDescription-pd_ethnicity').val();
}
function getPDHeight() {
    return $('#m1-Report-PhysicalDescription-pd_height').val();
}
function getPDWeight() {
    return $('#m1-Report-PhysicalDescription-pd_weight').val();
}
function getPDSkin() {
    return $('#m1-Report-PhysicalDescription-pd_skin').val();
}
function getPDHair() {
    return $('#m1-Report-PhysicalDescription-pd_hair').val();
}
function getPDEye() {
    return $('#m1-Report-PhysicalDescription-pd_eye').val();
}
function getPDDescribe() {
    return $('#m1-Report-PhysicalDescription-pd_describe').val();
}
//Contact Info
function getPDName() {
    return $('#m1-Report-PhysicalDescription-pd_name').val();
}
function getVictimContactEmail() {
    return $('#m1-Report-ContactInfo-contact_email').val();
}
function getVictimContactPhone() {
    return $('#m1-Report-ContactInfo-contact_phone').val();
}
function getVictimContactID() {
    return $('#m1-Report-ContactInfo-contact_ID').val();
}
//Tell Us
function getIncidentDescribe() {
    return $('#m1-Report-TellUs-tellus_describe').val();
}
//Your Contact Info
function getSenderAnonymous() {
    return $('#m1-Report-YourContactInfo-yourContact_ddb').val();
}
function getSenderName() {
    return $('#m1-Report-YourContactInfo-yourContact_name').val();
}
function getSenderPhone() {
    return $('#m1-Report-YourContactInfo-yourContact_phone').val();
}
function getSenderEmail() {
    return $('#m1-Report-YourContactInfo-yourContact_email').val();
}

/**
 * Notification that the page's HTML/CSS/JS is about to be loaded.
 * Perform custom logic here, f.e. you can cancel request to the server.
 * @param {String} targetScreenId 
 * @returns {boolean} true to continue loading; false to halt loading
 */
phoneui.prePageLoad = function(targetScreenId) {
  // add custom pre-load code here
  // return false to terminate page loading, this cancels transition to page as well
  return true;
}


/**
* Notification that the UI is about to transition to a new screen.
* Perform custom prescreen-transition logic here.
* @param {String} currentScreenId 
* @param {String} targetScreenId 
* @returns {boolean} true to continue transtion; false to halt transition
*/
phoneui.prePageTransition = function (currentScreenId, targetScreenId) {
    // add custom pre-transition code here
    // return false to terminate transition
    return true;
}

/**
* Notification that the UI has transitioned to a new screen.
* 
* @param {String} newScreenId 
*/
phoneui.postPageTransition = function (newScreenId) {
    if (newScreenId == '#m1-Language') {
        //rebind all list-items to be selectable
        phoneui.preprocessDOM('#m1-Language');
    }
}

/**
* Notification that device orientation has changed. 
* 
* @param {String} newOrientation 
*/
phoneui.postOrientationChange = function (newOrientation) {

}

/*************************************
    CALL THIS WHEN DOCUMENT IS LOADED
**************************************/
phoneui.documentReadyHandler = function () {
    getData(); //get selected Language from local storage
    populatePage(); //populate the app according to selected Language
    buildLanguageList(); //populate the language page with selected Language
    document.addEventListener("deviceready", onDeviceReady, false);
}
/*** CALL THIS WHEN DEVICE IS READY ***/
//called when cordova has initialized
function onDeviceReady() {
    document.addEventListener("resume", onDeviceResume, false);
    getGeoLocation(); //get GeoLocation when we start the app
}
//called when the app resumes from background
function onDeviceResume() {
    getGeoLocation(); //get GeoLocation when we resume the app
}
/*********************************
        POPULATE THE PAGE 
  ********************************/
function populatePage() {

    lang.en = json_english_label;
    lang.es = json_spanish_label;
    lang.fr = json_french_label;
    lang.pt = json_portuguese_label;
    lang.ru = json_russian_label;
    lang.th = json_thai_label;
    lang.zh = json_chinese_label;
    lang.nl = json_dutch_label;
    lang.ar = json_arabic_label;
    lang.hi = json_hindi_label;
//  lang.km = json_cambodian_label;
    if (lang[selectedLanguage] == null) {
        selectedLanguage = 'en';//set English to default language if selectedLanguage failed
    }

    // Controls text
    var backText = lang[selectedLanguage]["backText"];
    if (backText != null) {
    $("#m1-Report-Select-backBtn").html(lang[selectedLanguage]["backText"]);
    $("#m1-Report-LocationOfActivity-backBtn").html(lang[selectedLanguage]["backText"]);
    $("#m1-Report-TellUs-backBtn").html(lang[selectedLanguage]["backText"]);
    $("#m1-Report-ContactInfo-backBtn").html(lang[selectedLanguage]["backText"]);
    $("#m1-Report-PhysicalDescription-backBtn").html(lang[selectedLanguage]["backText"]);
    $("#m1-Report-YourContactInfo-backBtn").html(lang[selectedLanguage]["backText"]);
    $("#m1-WhatToLookFor-backBtn").html(lang[selectedLanguage]["backText"]);
    $("#m1-About-backBtn").html(lang[selectedLanguage]["backText"]);
    $("#m1-Policy-backBtn").html(lang[selectedLanguage]["backText"]);
    $("#m1-Language-backBtn").html(lang[selectedLanguage]["backText"]);
    } else {
      //alert('backText Error');
    }
    
    var backWidth = lang[selectedLanguage]["backSize"];
    if (backWidth != null) {
    $("#m1-Report-Select-backBtn").width(backWidth);
    $("#m1-Report-LocationOfActivity-backBtn").width(backWidth);
    $("#m1-Report-TellUs-backBtn").width(backWidth);
    $("#m1-Report-ContactInfo-backBtn").width(backWidth);
    $("#m1-Report-PhysicalDescription-backBtn").width(backWidth);
    $("#m1-Report-YourContactInfo-backBtn").width(backWidth);
    $("#m1-WhatToLookFor-backBtn").width(backWidth);
    $("#m1-About-backBtn").width(backWidth);
    $("#m1-Policy-backBtn").width(backWidth);
    $("#m1-Language-backBtn").width(backWidth);
    }

    // Page Titles
    $("#m1-Language-titleText").html(lang[selectedLanguage]["Languaage_title"]);
    $("#m1-About-titleText").html(lang[selectedLanguage]["About_title"]);
    $("#m1-Policy-titleText").html(lang[selectedLanguage]["Policy_title"]);
    $("#m1-WhatToLookFor-titleText").html(lang[selectedLanguage]["Look_for_title"]);
    $('#m1-Report-Select-reportSelectTitle').html(lang[selectedLanguage]["m1-Report-Select-Title"]);
    $('#m1-Report-LocationOfActivity-reportTitle').html(lang[selectedLanguage]["m1-Report_title"]);
    $('#m1-Report-TellUs-reportTitle').html(lang[selectedLanguage]["m1-Report_title"])
    $('#m1-Report-ContactInfo-reportTitle').html(lang[selectedLanguage]["m1-Report_title"]);
    $('#m1-Report-PhysicalDescription-reportTitle').html(lang[selectedLanguage]["m1-Report_title"]);
    $('#m1-Report-YourContactInfo-reportTitle').html(lang[selectedLanguage]["m1-Report_title"]);
      
    //Page1-MainMenu
    $('#m1-MainMenu-Report').html(lang[selectedLanguage]["m1-MainMenu-Report"]);
    $('#m1-MainMenu-Lookfor').html(lang[selectedLanguage]["m1-MainMenu-Lookfor"]);
    $('#m1-MainMenu-About').html(lang[selectedLanguage]["m1-MainMenu-About"]);
    $('#m1-MainMenu-Privacy').html(lang[selectedLanguage]["m1-MainMenu-Privacy"]);
    $('#m1-MainMenu-Language').html(lang[selectedLanguage]["m1-MainMenu-Language"]);
    //Page2-Report-Select
    $('#m1-Report-Select-ListHeader-label').html(lang[selectedLanguage]["m1-Report-Select-ListHeader-label"]);
    $('#m1-Report-Select-Victim').html(lang[selectedLanguage]["m1-Report-Select-Victim"]);
    $('#m1-Report-Select-Trafficker').html(lang[selectedLanguage]["m1-Report-Select-Trafficker"]);
    $('#m1-Report-Select-Activity').html(lang[selectedLanguage]["m1-Report-Select-Activity"]);
    //Page3-Report-LocationOfActivity
    $('#m1-Report-LocationOfActivity-reportdetail_lbl').html(lang[selectedLanguage]["m1-Report-reportdetail_lbl"]);
    $('#m1-Report-LocationOfActivity-loa_lbl').html(lang[selectedLanguage]["m1-Report-loa_lbl"]) ;
    $('#m1-Report-LocationOfActivity-type_lbl').html(lang[selectedLanguage]["m1-Report-LocationOfActivity-type_lbl"]) ;
    $('#m1-Report-LocationOfActivity-country_lbl').html(lang[selectedLanguage]["m1-Report-LocationOfActivity-country_lbl"]) ;
    $('#m1-Report-LocationOfActivity-city_lbl').html(lang[selectedLanguage]["m1-Report-LocationOfActivity-city_lbl"]) ;
    $('#m1-Report-LocationOfActivity-street_lbl').html(lang[selectedLanguage]["m1-Report-LocationOfActivity-street_lbl"]) ;
    $('#m1-Report-LocationOfActivity-method_lbl').html(lang[selectedLanguage]["m1-Report-LocationOfActivity-method_lbl"]) ;
    $('#m1-Report-LocationOfActivity-id_lbl').html(lang[selectedLanguage]["m1-Report-LocationOfActivity-id_lbl"]) ;
    $('#m1-Report-LocationOfActivity-details_lbl').html(lang[selectedLanguage]["m1-Report-LocationOfActivity-details_lbl"]) ;
    $('#m1-Report-LocationOfActivity-description_lbl').html(lang[selectedLanguage]["m1-Report-description_lbl"]) ;
    $('#m1-Report-LocationOfActivity-tellus_lbl').html(lang[selectedLanguage]["m1-Report-tellus_lbl"]) ;
    $('#m1-Report-LocationOfActivity-yourcontact_lbl').html(lang[selectedLanguage]["m1-Report-yourcontact_lbl"]) ; 
    $('#m1-Report-LocationOfActivity-submitButton').html(lang[selectedLanguage]["m1-Report-submitButton"]) ;

    //page4-Report-PhysicalDescription
    $('#m1-Report-PhysicalDescription-reportdetail_lbl').html(lang[selectedLanguage]["m1-Report-reportdetail_lbl"]) ;
    $('#m1-Report-PhysicalDescription-loa_lbl').html(lang[selectedLanguage]["m1-Report-loa_lbl"]) ;
    $('#m1-Report-PhysicalDescription-description_lbl').html(lang[selectedLanguage]["m1-Report-description_lbl"]) ;
    $('#m1-Report-PhysicalDescription-sex_lbl').html(lang[selectedLanguage]["m1-Report-PhysicalDescription-sex_lbl"]) ;
    $('#m1-Report-PhysicalDescription-age_lbl').html(lang[selectedLanguage]["m1-Report-PhysicalDescription-age_lbl"]) ;
    $('#m1-Report-PhysicalDescription-nationality_lbl').html(lang[selectedLanguage]["m1-Report-PhysicalDescription-nationality_lbl"]) ;
    $('#m1-Report-PhysicalDescription-ethnicity_lbl').html(lang[selectedLanguage]["m1-Report-PhysicalDescription-ethnicity_lbl"]) ;
    $('#m1-Report-PhysicalDescription-height_lbl').html(lang[selectedLanguage]["m1-Report-PhysicalDescription-height_lbl"]) ;
    $('#m1-Report-PhysicalDescription-weight_lbl').html(lang[selectedLanguage]["m1-Report-PhysicalDescription-weight_lbl"]) ;
    $('#m1-Report-PhysicalDescription-eye_lbl').html(lang[selectedLanguage]["m1-Report-PhysicalDescription-eye_lbl"]) ;
    $('#m1-Report-PhysicalDescription-hair_lbl').html(lang[selectedLanguage]["m1-Report-PhysicalDescription-hair_lbl"]) ;
    $('#m1-Report-PhysicalDescription-skin_lbl').html(lang[selectedLanguage]["m1-Report-PhysicalDescription-skin_lbl"]) ;
    $('#m1-Report-PhysicalDescription-feature_lbl').html(lang[selectedLanguage]["m1-Report-PhysicalDescription-feature_lbl"]) ;
    $('#m1-Report-PhysicalDescription-describe_lbl').html(lang[selectedLanguage]["m1-Report-PhysicalDescription-describe_lbl"]) ;
    $('#m1-Report-PhysicalDescription-tellus_lbl').html(lang[selectedLanguage]["m1-Report-tellus_lbl"]) ;
    $('#m1-Report-PhysicalDescription-yourcontact_lbl').html(lang[selectedLanguage]["m1-Report-yourcontact_lbl"]) ;
    $('#m1-Report-PhysicalDescription-submitButton').html(lang[selectedLanguage]["m1-Report-submitButton"]) ;
    //page5-Report-ContactInfo
    $('#m1-Report-ContactInfo-reportdetail_lbl').html(lang[selectedLanguage]["m1-Report-reportdetail_lbl"]) ;
    $('#m1-Report-ContactInfo-loa_lbl').html(lang[selectedLanguage]["m1-Report-loa_lbl"]) ; 
    $('#m1-Report-ContactInfo-description_lbl').html(lang[selectedLanguage]["m1-Report-description_lbl"]) ;  
    $('#m1-Report-ContactInfo-email_lbl').html(lang[selectedLanguage]["m1-Report-ContactInfo-email_lbl"]) ;  
    $('#m1-Report-ContactInfo-phone_lbl').html(lang[selectedLanguage]["m1-Report-ContactInfo-phone_lbl"]) ;  
    $('#m1-Report-ContactInfo-social_lbl').html(lang[selectedLanguage]["m1-Report-ContactInfo-social_lbl"]) ; 
    $('#m1-Report-ContactInfo-tellus_lbl').html(lang[selectedLanguage]["m1-Report-tellus_lbl"]) ; 
    $('#m1-Report-ContactInfo-yourcontact_lbl').html(lang[selectedLanguage]["m1-Report-yourcontact_lbl"]) ; 
    $('#m1-Report-ContactInfo-submitButton').html(lang[selectedLanguage]["m1-Report-submitButton"]) ; 
    //page6-Report-TellUs
    $('#m1-Report-TellUs-reportdetail_lbl').html(lang[selectedLanguage]["m1-Report-reportdetail_lbl"]) ;
    $('#m1-Report-TellUs-loa_lbl').html(lang[selectedLanguage]["m1-Report-loa_lbl"]) ;
    $('#m1-Report-TellUs-description_lbl').html(lang[selectedLanguage]["m1-Report-description_lbl"]) ;

    $('#m1-Report-TellUs-tellus_lbl').html(lang[selectedLanguage]["m1-Report-tellus_lbl"]) ;
    $('#m1-Report-TellUs-yourContact_lbl').html(lang[selectedLanguage]["m1-Report-yourcontact_lbl"]) ;
    $('#m1-Report-TellUs-describe_lbl').html(lang[selectedLanguage]["m1-Report-TellUs-describe_lbl"]) ;
    $('#m1-Report-TellUs-upload_lbl').html(lang[selectedLanguage]["m1-Report-TellUs-upload_lbl"]) ;
    $('#m1-Report-TellUs-yourcontact_lbl').html(lang[selectedLanguage]["m1-Report-yourcontact_lbl"]) ;
    $('#m1-Report-TellUs-uploaddetail_lbl').html(lang[selectedLanguage]["m1-Report-TellUs-uploaddetail_lbl"]) ;
    $('#m1-Report-TellUs-cameraButton').html(lang[selectedLanguage]["m1-Report-TellUs-cameraButton"]) ;
    $('#m1-Report-TellUs-browseButton').html(lang[selectedLanguage]["m1-Report-TellUs-browseButton"]) ;
    $('#m1-Report-TellUs-submitButton').html(lang[selectedLanguage]["m1-Report-submitButton"]) ;
   //page7 -Report-YourContactInfo
    $('#m1-Report-YourContactInfo-reportdetail_lbl').html(lang[selectedLanguage]["m1-Report-reportdetail_lbl"]) ;
    $('#m1-Report-YourContactInfo-loa_lbl').html(lang[selectedLanguage]["m1-Report-loa_lbl"]) ;
    $('#m1-Report-YourContactInfo-description_lbl').html(lang[selectedLanguage]["m1-Report-description_lbl"]) ;

    $('#m1-Report-YourContactInfo-tellus_lbl').html(lang[selectedLanguage]["m1-Report-tellus_lbl"]) ;
    $('#m1-Report-YourContactInfo-yourContact_lbl').html(lang[selectedLanguage]["m1-Report-yourcontact_lbl"]) ;
    $('#m1-Report-YourContactInfo-yourContactDetail_lbl').html(lang[selectedLanguage]["m1-Report-YourContactInfo-yourcontactdetail_lbl"]) ;
    $('#m1-Report-YourContactInfo-yourName_lbl').html(lang[selectedLanguage]["m1-Report-YourContactInfo-yourname_lbl"]) ; 
    $('#m1-Report-YourContactInfo-yourPhone_lbl').html(lang[selectedLanguage]["m1-Report-YourContactInfo-yourphone_lbl"]) ; 
    $('#m1-Report-YourContactInfo-yourEmail_lbl').html(lang[selectedLanguage]["m1-Report-YourContactInfo-youremail_lbl"]) ; 
    $('#m1-Report-YourContactInfo-submitButton').html(lang[selectedLanguage]["m1-Report-submitButton"]) ;
    //WhatToLookFor
    $('#m1-WhatToLookFor-label').html(lang[selectedLanguage]["m1-WhatToLookFor-label"]) ;
    $('#m1-WhatToLookFor-content').html(lang[selectedLanguage]["m1-WhatToLookFor-content"]) ;
    //About Orphan Secure
    $('#m1-About-label').html(lang[selectedLanguage]["m1-About-label"]) ;
    $('#m1-About-content').html(lang[selectedLanguage]["m1-About-content"]);

    /***OPEN URL IN BROWSER***/
    $("#OrphanSecureURL").click(function (event) {
        event.preventDefault();
        phoneui.showURL('http://www.orphansecure.com', '_child', { showLocationBar: true, showAddress: true, showNavigationBar: true });
    });

    //Policy
    $('#m1-Policy-label').html('<span>' + lang[selectedLanguage]["m1-Policy-label"] + '</span>');
    $('#m1-Policy-content').html('<span>' + lang[selectedLanguage]["m1-Policy-content"] + '</span>');

    //Error Page
    $('#m1-ErrorPage-label').html(lang[selectedLanguage]["m1-ErrorPage-label"]) ;
    $('#m1-ErrorPage-content').html(lang[selectedLanguage]["m1-ErrorPage-content"]);
    //SuccessPage
    $('#m1-SuccessPage-label').html(lang[selectedLanguage]["m1-SuccessPage-label"]) ;
    $('#m1-SuccessPage-content').html(lang[selectedLanguage]["m1-SuccessPage-content"]);
    
    /***POPULATE THE DROPDOWNLIST OPTIONS***/
    //LOCATION OF ACTIVITY
    //types
    var typeCnt = lang[selectedLanguage]["m1-Report-LocationOfActivity-type_option"].length; 
     for (i=0; i < typeCnt ; i++) {
         var lblType = lang[selectedLanguage]["m1-Report-LocationOfActivity-type_option"][i]["name"];
         var value = lang[selectedLanguage]["m1-Report-LocationOfActivity-type_option"][i]["value"];
         $("#m1-Report-LocationOfActivity-hidden-select-loa_type").append("<option value=\"" + value + "\" label=\"" + lblType + "\">" + lblType + "</option>");
     }
    //countries
    var countryCnt = lang[selectedLanguage]["m1-Report-LocationOfActivity-country_option"].length;
     for (i = 0; i < countryCnt; i++) {
         var lblCountry = lang[selectedLanguage]["m1-Report-LocationOfActivity-country_option"][i]["name"];
         var value = lang[selectedLanguage]["m1-Report-LocationOfActivity-country_option"][i]["value"];
         $("#m1-Report-LocationOfActivity-hidden-select-loa_country").append("<option value=\"" + value + "\" label=\"" + lblCountry + "\">" + lblCountry + "</option>");
     }
     // set the preselected contry based on geoLocation
     if (countryName != undefined || countryName != '') {
        $("#m1-Report-LocationOfActivity-hidden-select-loa_country").val(countryName);
     }
    //method
      var methodCnt = lang[selectedLanguage]["m1-Report-LocationOfActivity-method_option"].length; 
     for (i=0; i < methodCnt ; i++) {
         var lblMethod = lang[selectedLanguage]["m1-Report-LocationOfActivity-method_option"][i]["name"];
         var value = lang[selectedLanguage]["m1-Report-LocationOfActivity-method_option"][i]["value"];
         $("#m1-Report-LocationOfActivity-hidden-select-loa_tranMethod").append("<option value=\"" + value + "\" label=\"" + lblMethod + "\">" + lblMethod + "</option>");
     }

    //PHYSICAL DESCRIPTION
    //sex
       var sexCnt = lang[selectedLanguage]["m1-Report-PhysicalDescription-sex_option"].length; 
     for (i=0; i < sexCnt ; i++) {
         var lblsex = lang[selectedLanguage]["m1-Report-PhysicalDescription-sex_option"][i]["name"];
         var value = lang[selectedLanguage]["m1-Report-PhysicalDescription-sex_option"][i]["value"];
         $("#m1-Report-PhysicalDescription-hidden-select-pd_sex").append("<option value=\"" + value + "\" label=\"" + lblsex + "\">" + lblsex + "</option>");
     }
    //age
    var ageCnt = lang[selectedLanguage]["m1-Report-PhysicalDescription-age_option"].length; 
     for (i=0; i < ageCnt ; i++) {
         var lblage = lang[selectedLanguage]["m1-Report-PhysicalDescription-age_option"][i]["name"];
         var value = lang[selectedLanguage]["m1-Report-PhysicalDescription-age_option"][i]["value"];
         $("#m1-Report-PhysicalDescription-hidden-select-pd_age").append("<option value=\"" + value + "\" label=\"" + lblage + "\">" + lblage + "</option>");
     }
    //nationality
    var nationalityCnt = lang[selectedLanguage]["m1-Report-PhysicalDescription-nationality_option"].length; 
     for (i=0; i < nationalityCnt ; i++) {
         var lblnationality = lang[selectedLanguage]["m1-Report-PhysicalDescription-nationality_option"][i]["name"];
         var value = lang[selectedLanguage]["m1-Report-PhysicalDescription-nationality_option"][i]["value"];
         $("#m1-Report-PhysicalDescription-hidden-select-pd_nationality").append("<option value=\"" + value + "\" label=\"" + lblnationality + "\">" + lblnationality + "</option>");
     }
     //ethnicity
    var ethnicityCnt = lang[selectedLanguage]["m1-Report-PhysicalDescription-ethnicity_option"].length; 
     for (i=0; i < ethnicityCnt ; i++) {
         var lblethnicity = lang[selectedLanguage]["m1-Report-PhysicalDescription-ethnicity_option"][i]["name"];
         var value = lang[selectedLanguage]["m1-Report-PhysicalDescription-ethnicity_option"][i]["value"];
         $("#m1-Report-PhysicalDescription-hidden-select-pd_ethnicity").append("<option value=\"" + value + "\" label=\"" + lblethnicity + "\">" + lblethnicity + "</option>");
     }
      //eyecolor
    var eyecolorCnt = lang[selectedLanguage]["m1-Report-PhysicalDescription-eyecolor_option"].length; 
     for (i=0; i < eyecolorCnt ; i++) {
         var lbleyecolor = lang[selectedLanguage]["m1-Report-PhysicalDescription-eyecolor_option"][i]["name"];
         var value = lang[selectedLanguage]["m1-Report-PhysicalDescription-eyecolor_option"][i]["value"];
         $("#m1-Report-PhysicalDescription-hidden-select-pd_eye").append("<option value=\"" + value + "\" label=\"" + lbleyecolor + "\">" + lbleyecolor + "</option>");
     }
        //haircolor
    var haircolorCnt = lang[selectedLanguage]["m1-Report-PhysicalDescription-haircolor_option"].length; 
     for (i=0; i < haircolorCnt ; i++) {
         var lblhaircolor = lang[selectedLanguage]["m1-Report-PhysicalDescription-haircolor_option"][i]["name"];
         var value = lang[selectedLanguage]["m1-Report-PhysicalDescription-haircolor_option"][i]["value"];
         $("#m1-Report-PhysicalDescription-hidden-select-pd_hair").append("<option value=\"" + value + "\" label=\"" + lblhaircolor + "\">" + lblhaircolor + "</option>");
     }
         //skincolor
    var skincolorCnt = lang[selectedLanguage]["m1-Report-PhysicalDescription-skincolor_option"].length; 
     for (i=0; i < skincolorCnt ; i++) {
         var lblskincolor = lang[selectedLanguage]["m1-Report-PhysicalDescription-skincolor_option"][i]["name"];
         var value = lang[selectedLanguage]["m1-Report-PhysicalDescription-skincolor_option"][i]["value"];
         $("#m1-Report-PhysicalDescription-hidden-select-pd_skin").append("<option value=\"" + value + "\" label=\"" + lblskincolor + "\">" + lblskincolor + "</option>");
     }
            //feature
    var featureCnt = lang[selectedLanguage]["m1-Report-PhysicalDescription-feature_option"].length; 
     for (i=0; i < featureCnt ; i++) {
         var lblfeature = lang[selectedLanguage]["m1-Report-PhysicalDescription-feature_option"][i]["name"];
         var value = lang[selectedLanguage]["m1-Report-PhysicalDescription-feature_option"][i]["value"];
         $("#m1-Report-PhysicalDescription-hidden-select-pd_feature").append("<option value=\"" + value + "\" label=\"" + lblfeature + "\">" + lblfeature + "</option>");
     }
    //SUBMITTER CONTACT INFO
      var yourcontactCnt = lang[selectedLanguage]["m1-Report-YourContactInfo-yourcontact_option"].length; 
     for (i=0; i < yourcontactCnt ; i++) {
         var lblyourcontact = lang[selectedLanguage]["m1-Report-YourContactInfo-yourcontact_option"][i]["name"];
         var value = lang[selectedLanguage]["m1-Report-YourContactInfo-yourcontact_option"][i]["value"];
         $("#m1-Report-YourContactInfo-hidden-select-yourContact_ddb").append("<option value=\"" + value + "\" label=\"" + lblyourcontact + "\">" + lblyourcontact + "</option>");
     }
}

//those custom labels are created after other labels b/c the user has to choose a report type first
function populateCustomLabel(choice) {
    $('#m1-Report-LocationOfActivity-report_lbl').html(lang[selectedLanguage]["m1-Report-LocationOfActivity-report_lbl"][choice]);    
    $('#m1-Report-PhysicalDescription-report_lbl').html(lang[selectedLanguage]["m1-Report-PhysicalDescription-report_lbl"][choice]);   
    $('#m1-Report-ContactInfo-report_lbl').html(lang[selectedLanguage]["m1-Report-ContactInfo-report_lbl"][choice]);  
    $('#m1-Report-TellUs-report_lbl').html(lang[selectedLanguage]["m1-Report-TellUs-report_lbl"][choice]); 
    $('#m1-Report-YourContactInfo-report_lbl').html(lang[selectedLanguage]["m1-Report-YourContactInfo-report_lbl"][choice]);  
    $('#m1-Report-PhysicalDescription-name_lbl').html(lang[selectedLanguage]["m1-Report-PhysicalDescription-name_lbl"][choice]);   
    $('#m1-Report-ContactInfo-contactdetail_lbl').html(lang[selectedLanguage]["m1-Report-ContactInfo-contactdetail_lbl"][choice]);
    $('#m1-Report-LocationOfActivity-contact_lbl').html(lang[selectedLanguage]["m1-Report-LocationOfActivity-contact_lbl"][choice]);  
    $('#m1-Report-PhysicalDescription-contact_lbl').html(lang[selectedLanguage]["m1-Report-PhysicalDescription-contact_lbl"][choice]);
    $('#m1-Report-ContactInfo-contact_lbl').html(lang[selectedLanguage]["m1-Report-ContactInfo-contact_lbl"][choice]);
    $('#m1-Report-TellUs-contact_lbl').html(lang[selectedLanguage]["m1-Report-TellUs-contact_lbl"][choice]);
    $('#m1-Report-YourContactInfo-contact_lbl').html(lang[selectedLanguage]["m1-Report-YourContactInfo-contact_lbl"][choice]);
    
}


/*************************************
        APPS DISPLAY FUNCTIONS
**************************************/
function buildLanguageList() {
    // Array of items to fill SL
    var items = json_language;
    // Selected item index
    var selItemIndex = 0;
    // Store old items (will remove them later)
    var olditems = $('#m1-Language-list1').children();
    // First of old items is our template
    var templ = $(olditems[0]);
    //i == selItemIndex ||
    // Do for each data item
    $.each(items, function(i, val) {
    // Clone template
    var clone = templ.clone();
    // Set correct value for "first" class
    clone[(i == 0) ? "addClass" : "removeClass"](m1Design.css('first'));
    // Set correct value for "last" class
    clone[(i == (items.length-1)) ? "addClass" : "removeClass"](m1Design.css('last'));
    // Process selected item
    clone[( val.code == selectedLanguage) ? "addClass" : "removeClass"](m1Design.css('selected'));
    // Set "value" item (it will be set to <select><option VALUE> attribute when doign POST to server)
    clone.attr('data-val',val.code);
    // Set text label
    clone.find('label').text(val.name);
    // We're done, add element to list item
    clone.appendTo(templ.parent());
    });

    // Remove old items
    olditems.remove();
    // Don't forget to sync internal phoneui state
    //phoneui.preprocessDOM(phoneui.getCurrentPageId());
    phoneui.forceLayout('#m1-Language-languagePanel');
}

//change Language display
function changeSelectedLanguage(){
    saveData();
    getData();
    resetOptionList(); //need to RESET the list everytime the Language change
    populatePage();
    phoneui.gotoPage('m1-MainMenu','SLIDE_RIGHT');

}

/*SELECT TYPE OF REPORT*/
function reportVictim() {
    selectedReportType = 0;    
    selectedReport = "Victim";
    populateCustomLabel(selectedReportType);
    phoneui.gotoPage('m1-Report_LocationOfActivity', 'SLIDE_LEFT')
}
function reportTrafficker() {
    selectedReportType = 1;    
    selectedReport = "Trafficker";
    populateCustomLabel(selectedReportType);
    phoneui.gotoPage('m1-Report_LocationOfActivity', 'SLIDE_LEFT')
}
function reportSuspiciousActivity() {
    selectedReportType = 2;    
    selectedReport = "Suspicious Activity";
    populateCustomLabel(selectedReportType);
    phoneui.gotoPage('m1-Report_LocationOfActivity', 'SLIDE_LEFT')
}

/***LOCAL STORAGE FUNCTIONS***/
function getData() {
    if (!window.localStorage) {
        warnNoLocStorage();
        return;
    }
    var key = 1;
    var data = localStorage.getItem(key);
    selectedLanguage = data;
}
function saveData() {
    if (!window.localStorage) {
        warnNoLocStorage();
        return;
    }
    var key = 1;
    var data = $('#m1-Language-list1 li[class~="m1-selected"]').attr('data-val');
    localStorage.setItem(key, data);
}
function warnNoLocStorage() {
    //alert('Local Storage not available');
}
/*============APPS DISPLAY FUNCTIONS END HERE==============*/

/*************************************
        RESET FORM FUNCTION
**************************************/
function resetOptionList() {
    //types
    $("#m1-Report-LocationOfActivity-hidden-select-loa_type").empty();
    //countries
    $("#m1-Report-LocationOfActivity-hidden-select-loa_country").empty();
    //method
    $("#m1-Report-LocationOfActivity-hidden-select-loa_tranMethod").empty();
    //yourcontact
    $("#m1-Report-YourContactInfo-hidden-select-loa_yourContact").empty();
    //Physical Description
    //sex
    $("#m1-Report-PhysicalDescription-hidden-select-pd_sex").empty();
    //age
    $("#m1-Report-PhysicalDescription-hidden-select-pd_age").empty();
    //nationality
    $("#m1-Report-PhysicalDescription-hidden-select-pd_nationality").empty();
    //ethnicity
    $("#m1-Report-PhysicalDescription-hidden-select-pd_ethnicity").empty();
    //eyecolor
    $("#m1-Report-PhysicalDescription-hidden-select-pd_eye").empty();
    //haircolor
    $("#m1-Report-PhysicalDescription-hidden-select-pd_hair").empty();
    //skincolor
    $("#m1-Report-PhysicalDescription-hidden-select-pd_skin").empty();
    //feature
    $("#m1-Report-PhysicalDescription-hidden-select-pd_feature").empty();
    //
    $("#m1-Report-YourContactInfo-hidden-select-yourContact_ddb").empty();
}
function resetForm() {
    $('#m1-Report-LocationOfActivity-loa_type').empty();
    $('#m1-Report-LocationOfActivity-loa_country').empty()
    $('#m1-Report-LocationOfActivity-loa_city').val('');
    $('#m1-Report-LocationOfActivity-loa_street').val('');
    $('#m1-Report-LocationOfActivity-loa_tranMethod').empty();
    $('#m1-Report-LocationOfActivity-loa_tranID').val('');
    $('#m1-Report-LocationOfActivity-loa_detail').val('');
    $('#m1-Report-PhysicalDescription-pd_sex').empty();
    $('#m1-Report-PhysicalDescription-pd_age').empty();
    $('#m1-Report-PhysicalDescription-pd_nationality').empty();
    $('#m1-Report-PhysicalDescription-pd_ethnicity').empty();
    $('#m1-Report-PhysicalDescription-pd_height').val('');
    $('#m1-Report-PhysicalDescription-pd_weight').val('');
    $('#m1-Report-PhysicalDescription-pd_skin').empty();
    $('#m1-Report-PhysicalDescription-pd_hair').empty();
    $('#m1-Report-PhysicalDescription-pd_eye').empty();
    $('#m1-Report-PhysicalDescription-pd_describe').val('');
    $('#m1-Report-PhysicalDescription-pd_name').val('');
    $('#m1-Report-ContactInfo-contact_email').val('');
    $('#m1-Report-ContactInfo-contact_phone').val('');
    $('#m1-Report-ContactInfo-contact_ID').val('');
    $('#m1-Report-TellUs-tellus_describe').val('');
    $('#m1-Report-YourContactInfo-yourContact_ddb').empty();
    $('#m1-Report-YourContactInfo-yourContact_name').val('');
    $('#m1-Report-YourContactInfo-yourContact_phone').val('');
    $('#m1-Report-YourContactInfo-yourContact_email').val('');
    imageBase64String = "";
    valid = true;
    $('#m1-Report-ContactInfo-contact_email').removeClass("errorTextbox");
    $('#m1-Report-YourContactInfo-yourContact_email').removeClass("errorTextbox");
    document.getElementById('m1-Report-TellUs-image1').src = "";
}

/***PHOTO FUNCTIONS ***/
function capturePhoto() {
    navigator.camera.getPicture(onPhotoDataSuccess, onPhotoDataFail, { quality: 60, destinationType: Camera.DestinationType.DATA_URL, encodingType: Camera.EncodingType.JPEG});
}
function browsePhoto() {
    navigator.camera.getPicture(onPhotoDataSuccess, onPhotoDataFail, { quality: 60, destinationType: navigator.camera.DestinationType.DATA_URL, sourceType: navigator.camera.PictureSourceType.PHOTOLIBRARY, encodingType: Camera.EncodingType.JPEG, mediaType: Camera.MediaType.PICTURE });
}
function onPhotoDataSuccess(imageData) {
    startSpinner();
    var image = document.getElementById('m1-Report-TellUs-image1');
    image.src = "data:image/jpeg;base64," + imageData;//print to the screen
    imageBase64String =  imageData;//get base64
    phoneui.preprocessDOM("#m1-Report-TellUs");
    phoneui.forceLayout("#m1-Report-TellUs"); //reset the layout
    stopSpinner();
    phoneui.resizeScreen();
}
function onPhotoDataFail(message) {
    // alert(message);
    phoneui.resizeScreen();
}

/*** GEO LOCATION FUNCTIONS ***/
function getGeoLocation() {
    navigator.geolocation.getCurrentPosition(onGeoSuccess, onGeoError, { maximumAge: 3000, timeout: 5000, enableHighAccuracy: true });
};
// onSuccess Callback
//   This method accepts a `Position` object, which contains
//   the current GPS coordinates
function onGeoSuccess(position) {
    geoLatitude = position.coords.latitude;
    geoLongitude = position.coords.longitude;
    /*
    $.getJSON("http://api.geonames.org/countryCode?lat="+ geoLatitude +"&lng="+ geoLongitude +"&username=orphansecure&type=JSON", 
        function(data) {
            if (data.countryCode != undefined || data.countryCode !='') {
                countryCode = data.countryCode;
                
            }
            if (data.countryName != undefined || data.countryName != '') {
                countryName = data.countryName;
                $("#m1-Report-LocationOfActivity-hidden-select-loa_country").val(countryName);
            }

    });
    */
    /*
    var url = "http://maps.googleapis.com/maps/api/geocode/json?sensor=false&address=" + geoLatitude + "," + geoLongitude;
    
    $.ajax(url).done(function (responseData) {
        var address_components = eval(responseData).results[0].address_components;
        var countryName = address_components[address_components.length - 2].long_name;
        $("#m1-Report-LocationOfActivity-hidden-select-loa_country").val(countryName);
     //   alert(countryName);
    });
    */
};
// onError Callback receives a PositionError object
function onGeoError(error) {    
 // alert('code: '+ error.code + '\n' + 'message: ' + error.message + '\n'); 
}


/*********************************************
                SUBMIT BUTTON
**********************************************/
function PostFormData() {
    //check form before post
    valid = true;
    validateForm();
    if (!valid) {     
        // alert dialog
        $.jqDialog.alert("Please correct the error(s)", function () {	
            // callback function for 'OK' button           
        });
    }
    else { //post Form
        startSpinner();
        $.post(
        "http://orphansecure.elasticbeanstalk.com/OSwebService.aspx", //call web service
        {
        "Type": getLOAType(),
        "Country": getLOACountry(),
        "City": getLOACity(),
        "Street": getLOAStreet(),
        "TransMethod": getLOATranMethod(),
        "TransID": getLOATranID(),
        "LocationDetail": getLOADetail(),
        "Name": getPDName(),
        "Sex": getPDSex(),
        "Age": getPDAge(),
        "Nationality": getPDNationality(),
        "Ethnicity": getPDEthnicity(),
        "Height": getPDHeight(),
        "Weight": getPDWeight(),
        "Skin": getPDSkin(),
        "Hair": getPDHair(),
        "Eye": getPDEye(),
        "PhysicalDescribe": getPDDescribe(),
        "ContactEmail": getVictimContactEmail(),
        "ContactPhone": getVictimContactPhone(),
        "ContactID": getVictimContactID(),
        "IncidentDescribe": getIncidentDescribe(),
        "SenderAnonymous": getSenderAnonymous(),
        "SenderName": getSenderName(),
        "SenderPhone": getSenderPhone(),
        "SenderEmail": getSenderEmail(),
        "ReportType": selectedReport,
        "GeoLatitude": geoLatitude,
        "GeoLongitude": geoLongitude,
        "ImageBase64": imageBase64String
    },
      function (data) {
          /*
          if (data.Success) {
          alert('Success!!');
          } else {
          alert('Fail!!');
          }
          if (data.message != null && data.message.length > 0) {
          alert(data.message);
          }
          */
      },"json").done(
                    function () {
                        phoneui.gotoPage('m1-SuccessPage', 'SLIDE_LEFT');
                        //alert("second success");
                     }
                    ).fail(
                        function (jqXHR, textStatus, errorThrown) {
                        phoneui.gotoPage('m1-ErrorPage', 'SLIDE_LEFT');
                        // alert(textStatus + ": my error is " + errorThrown); 
                        }
                    ).always(
                        function () {
                        stopSpinner();
                        //alert("finished"); 
                        }
                    );
    }//end valid check
}

/***FORM VALIDATION***/
function validateForm() {
    /*
    //Type
    if ($('#m1-Report-LocationOfActivity-loa_type').text() == '') {
    $('#m1-Report-LocationOfActivity-loa_type').addClass("errorDropDown");
    valid = false;
    }
    else{
    $('#m1-Report-LocationOfActivity-loa_type').removeClass("errorDropDown");
    }
    //Country
    if ($('#m1-Report-LocationOfActivity-loa_country').text() == '') {
    $('#m1-Report-LocationOfActivity-loa_country').addClass("errorDropDown");
    valid = false;
    }
    else{
    $('#m1-Report-LocationOfActivity-loa_country').removeClass("errorDropDown");
    }
    //City
    if ($('#m1-Report-LocationOfActivity-loa_city').val() == '') {
    $('#m1-Report-LocationOfActivity-loa_city').addClass("errorTextbox");
    valid = false;
    }
    else if ($('#m1-Report-LocationOfActivity-loa_city').val() != '') {
    $('#m1-Report-LocationOfActivity-loa_city').removeClass("errorTextbox");
    }
    //Street
    if ($('#m1-Report-LocationOfActivity-loa_street').val() == '') {
    $('#m1-Report-LocationOfActivity-loa_street').addClass("errorTextbox");
    valid = false;
    }
    else if ($('#m1-Report-LocationOfActivity-loa_street').val() != '') {
    $('#m1-Report-LocationOfActivity-loa_street').removeClass("errorTextbox");
    }
    */
    //validate email when it not empty
    if ($('#m1-Report-ContactInfo-contact_email').val() != '') {
        if (!validateEmail($('#m1-Report-ContactInfo-contact_email').val())) {
            $('#m1-Report-ContactInfo-contact_email').addClass("errorTextbox");
            valid = false;
        }
        else {
            $('#m1-Report-ContactInfo-contact_email').removeClass("errorTextbox");
        }
    }
    if ($('#m1-Report-YourContactInfo-yourContact_email').val() != '') {
        if (!validateEmail($('#m1-Report-YourContactInfo-yourContact_email').val())) {
            $('#m1-Report-YourContactInfo-yourContact_email').addClass("errorTextbox");
            valid = false;
        }
        else {
            $('#m1-Report-YourContactInfo-yourContact_email').removeClass("errorTextbox");
        }
    }
   
}
//validate email function
function validateEmail(email) {
    var emailReg = /^([\w-\.]+@([\w-]+\.)+[\w-]{2,4})?$/;
    if (!emailReg.test(email)) {
        return false;
    } else {
        return true;
    }
}

/*** SPINNER ***/
function startSpinner() {
    //set spinner shape
    $.fn.spin.presets.circle = {
        lines: 9,
        length: 15,
        width: 6,
        radius: 10
    }

    $('.spinner').remove(); //remove previous spinner class
    $('body').append('<div class="spinner"></div>');
    $('.spinner').css({ 'width': '100%', 'height': $(window).height(), 'z-index': '1000', 'background-color': '#000', 'opacity': '.4' });
    //stop any touch events
    $('.spinner').click(function (e) {
        e.preventDefault();
    });
    //start spinner
    $('.spinner').spin('circle', 'white');
}
function stopSpinner() {
    $('.spinner').spin(false); //stop spinner
    $('.spinner').remove();
}

/*** NAVIGATION FUNCTIONS***/
function gotoMainMenu() {
    phoneui.gotoPage('m1-MainMenu', 'SLIDE_RIGHT');
    resetForm();
}
function gotoSelectMenu() {
    phoneui.gotoPage('m1-Report_Select', 'SLIDE_RIGHT');
    resetForm();
}


/***  DISABLE BACK BUTTON ON ADROID
document.addEventListener("deviceready", onDeviceReady, false);

// PhoneGap is loaded and it is now safe to make calls PhoneGap methods
//
function onDeviceReady() {
    // Register the event listener
    document.addEventListener("backbutton", onBackKeyDown, false);
}

// Handle the back button
//
function onBackKeyDown() {

}
***/

/*
// set the height to auto
alert($('#m1-Policy-content').height());
adjustTextHeight($('#m1-Policy-content'), $('#m1-Policy-scrollpanel'), lang[selectedLanguage]["m1-Policy-content"]);
alert($('#m1-Policy-content').height());
phoneui.forceLayout('#m1-Policy');
alert($('#m1-Policy-content span')[0].scrollHeight);
$('#m1-Policy-scrollpanel-scroller').attr('data-layout-content-height', 1000);
$('#m1-Policy-scrollpanel-scroller')[0].myScroll.refresh();

function adjustTextHeight($text, $panel, text) {
    $text.css({ 'height': '1px' });
    $text.empty();
    var sandbox = $('<span/>').text(text).appendTo($text);
    var current_height = $text[0].scrollHeight;
    $text.empty().text(text);
    $text.css({ 'height': current_height + 'px' });
    var panel_height = current_height + 10; // sets the panel with an extra 10 pixels with respect to the text
    if ($panel) { $panel.css({ 'height': panel_height + 'px' }); }
};
*/

/*** FIX THE SCROLLING ON ANDROID WHEN KEYBOARD IS UP ***/
var $elm;
$('input, textarea').bind('focus', function(e) {
    //console.error("onFocus");
    $elm = $(this);
});
//Then, using "resize" event, I refreshed the iscroll object and then scroll to the $elm.

$(window).bind('resize', function() {
   // console.error("onResize");
    if (myScroll !== undefined) {
        setTimeout(function() {
            myScroll.refresh();
            myScroll.scrollToElement($elm[0], 200);
        }, 100);
    }
});


